"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const net_1 = require("net");
const client_1 = require("./../api/client");
const logger_1 = require("../utils/logger");
function attach({ reader: _reader, writer: _writer, proc, socket, }) {
    let writer;
    let reader;
    if (socket) {
        const client = net_1.createConnection(socket);
        writer = client;
        reader = client;
    }
    else if (_reader && _writer) {
        writer = _writer;
        reader = _reader;
    }
    else if (proc) {
        writer = proc.stdin;
        reader = proc.stdout;
    }
    if (writer && reader) {
        const neovim = new client_1.NeovimClient({ logger: logger_1.logger });
        neovim.attach({
            writer,
            reader,
        });
        return neovim;
    }
    throw new Error('Invalid arguments, could not attach');
}
exports.attach = attach;
